﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using log4net;
using System.Reflection;

namespace Bl.CsharPlagger.Win
{
    /// <summary>
    /// ApplicationContextの実装
    /// </summary>
    public class PlaggerContext : ApplicationContext
    {
        private static readonly ILog logger = LogManager.GetLogger(MethodBase.GetCurrentMethod().DeclaringType);

        /// <summary>
        /// コンストラクタ
        /// </summary>
        /// <param name="main"></param>
        public PlaggerContext(Form main)
        {
            Application.ApplicationExit += new EventHandler(Application_ApplicationExit);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);

            main.FormClosed += new FormClosedEventHandler(main_FormClosed);

            main.Show();
        }

        /// <summary>
        /// スレッド例外
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            throw e.Exception;
        }

        /// <summary>
        /// アプリケーション終了時
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void Application_ApplicationExit(object sender, EventArgs e)
        {
        }

        /// <summary>
        /// フォーム閉じた際
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void main_FormClosed(object sender, FormClosedEventArgs e)
        {
            Application.ExitThread();
        }
    }
}
